<?php namespace Phpcmf\Controllers\Admin;

class Test extends \Phpcmf\Table
{

public function __construct(...$params)
{
    parent::__construct(...$params);
    // 表单显示名称
    $this->name = dr_lang('资料数据');
    // 模板前缀(避免混淆)
    $this->tpl_prefix = 'test_';
    // 主要字段
    $field = array(
        'title' => array(
            'ismain' => 1,
            'name' => dr_lang('名称'),
            'fieldname' => 'title',
            'fieldtype' => 'Text',
            'setting' => array(
                'option' => array(
                    'width' => 200,
                ),
                'validate' => array(
                    'required' => 1,
                )
            )
        ),
        'content' => array(
            'ismain' => 1,
            'name' => dr_lang('资料内容'),
            'fieldtype' => 'Ueditor',
            'fieldname' => 'content',
            'setting' => array(
                'option' => array(
                    'mode' => 1,
                    'height' => 300,
                    'width' => '100%'
                ),
                'validate' => array(
                    'required' => 1,
                )
            )
        ),
    );
    // 初始化数据表
    $this->_init([
        'table' => 'test',
        'field' => $field,
        'show_field' => 'title',
        'order_by' => 'id desc',
    ]);
    \Phpcmf\Service::V()->assign([
        'field' => $field,
        'menu' => \Phpcmf\Service::M('auth')->_admin_menu(
        [
            $this->name => [APP_DIR.'/'.\Phpcmf\Service::L('Router')->class.'/index', 'fa fa-tag'],
            '添加' => [APP_DIR.'/'.\Phpcmf\Service::L('Router')->class.'/add', 'fa fa-plus'],
            '修改' => ['hide:'.APP_DIR.'/'.\Phpcmf\Service::L('Router')->class.'/edit', 'fa fa-edit'],
        ])
    ]);
}

    // 查看列表
    public function index() {
        list($tpl) = $this->_List();
        \Phpcmf\Service::V()->display($tpl);
    }

    // 添加内容
    public function add() {
        list($tpl) = $this->_Post(0);
        \Phpcmf\Service::V()->display($tpl);
    }

    // 修改内容
    public function edit() {
        list($tpl) = $this->_Post(intval(\Phpcmf\Service::L('Input')->get('id')));
        \Phpcmf\Service::V()->display($tpl);
    }

    // 删除内容
    public function del() {
        $this->_Del(
            \Phpcmf\Service::L('Input')->get_post_ids(),
            null,
            null,
            \Phpcmf\Service::M()->dbprefix($this->init['table'])
        );
    }

    // 保存内容 
    protected function _Save($id = 0, $data = [], $old = [], $func = null, $func2 = null) {
        return parent::_Save($id, $data, $old, function($id, $data, $old){
            // 保存之前执行的函数，并返回新的数据
            if (!$id) {
                // 当提交新数据时，把当前时间插入进去
                $data[1]['inputtime'] = SYS_TIME;
            }
            
            return dr_return_data(1, null, $data);
        }, function ($id, $data, $old) {
            // 保存之后执行的动作
        });
    }

}
